package net.metaunix.services;

import java.util.Arrays;
import javafx.concurrent.ScheduledService;
import javafx.concurrent.Task;
import oshi.SystemInfo;
import oshi.hardware.CentralProcessor;
import oshi.hardware.HardwareAbstractionLayer;
import oshi.hardware.Sensors;
import oshi.software.os.OperatingSystem;

import net.metaunix.SysInfo;

public class UpdateSystemInfoService extends ScheduledService<Void> {

  private static int counter = 0;

  @Override
  protected Task<Void> createTask() {
    return new Task<>() {

      @Override
      protected Void call() throws Exception {
        UpdateSystemInfoService.counter++;

        SystemInfo si = new SystemInfo();
        OperatingSystem os = si.getOperatingSystem();
        SysInfo.osString = String.valueOf(UpdateSystemInfoService.counter) + " " + String.valueOf(os);

        HardwareAbstractionLayer hal = si.getHardware();
        Sensors sensors = hal.getSensors();
        SysInfo.cpuTemp = sensors.getCpuTemperature();
        CentralProcessor cpu = hal.getProcessor();
        SysInfo.cpuMaxFreq = cpu.getMaxFreq();

        long[] freqs = cpu.getCurrentFreq();
        Arrays.sort(freqs);
        SysInfo.cpuFreq = freqs[freqs.length - 1];

        return null;
      }

    };
  }

}
